// pages/userCenter.js
const app = getApp()
const wxService = require('../../utils/wxService')
const utils = require('../../utils/util')
const envInfo = require('../../config/index').envInfo

wxService.page({
  /**
   * 页面的初始数据
   */
  data: {
    params: {
      pageNo: '1',
      pageSize: '10'
    },
    totalPages: ''
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    this.initIntegralCouponList()
  },

  //获取消费列表
  initIntegralCouponList(type) {
    wx.showLoading({
      title: '加载中'
    })
    wxService.get(`/coupon/pointsRedemptionCouponSetting/findPage?pageNo=${this.data.params.pageNo}&pageSize=${this.data.params.pageSize}`).then(res => {
      let integralCouponList = [];
      integralCouponList = this.data.params.pageNo == 1 ? res.data.data : this.data.integralCouponList.concat(res.data.data);
      this.setData({
        integralCouponList,
        totalPages: res.data.data.totalPages,
      })
      wx.hideLoading();
      if (type && type.pullDown) wx.stopPullDownRefresh();
    }).finally(() => {
      wx.hideLoading();
      this.setData({
        integralCouponList: ''
      })
    })
  },

  /**
  * 页面相关事件处理函数--监听用户下拉动作
  */
  onPullDownRefresh: function () {
    this.setData({
      params: {
        pageNo: 1,
        pageSize: 10,
      },
    })
    this.initIntegralCouponList({
      pullDown: true
    });
  },

  /**
   * 页面上拉触底事件的处理函数
   */
  bindDownLoad: function () {
    if (this.data.params.pageNo < this.data.totalPages) {
      this.setData({
        params: {
          pageNo: this.data.params.pageNo + 1,
          pageSize: 10
        },
        loadDataDone: true
      })
      this.initIntegralCouponList()
    }
  },
})