// pages/coupons.js
const app = getApp()
const wxService = require('../../utils/wxService')
const utils = require('../../utils/util')
const envInfo = require('../../config/index').envInfo

wxService.page({
  /**
   * 页面的初始数据
   */
  data: {
    nav:[
      {
        type:'1',
        name:'可使用'
      },{
        type:'2',
        name:'已失效'
      }
    ],
    navIndex:'1',
    params:{
      pageNo:1,
      pageSize:10
    },
    queryData:{
      query:{
        "brandId": 0,
        "couponSettingId": 0,
        "status": 0,
        "title": ""
      }
    },
    totalPages:''
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {

  },

 
  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    this.queryData.setData({
      'query.status': this.data.navIndex
    })
    this.getCouponList()
  },

  //切换tab
  switchTab(e){
    this.setData({
      navIndex: e.currentTarget.dataset.index,
      'query.status': e.currentTarget.dataset.index
    })
    this.getCouponList()
  },

  //获取优惠券列表
  getCouponList(type){
    wx.showLoading({
      title: '加载中'
    })
    this.queryData.setData({
      'query.status': this.data.navIndex
    })
    wxService.post(`/coupon/coupon/setting/list?pageNo=${this.data.params.pageNo}&pageSize=${this.data.params.pageSize}`, this.queryData).then(res => {
      let couponList = [];
      couponList = this.data.params.pageNo == 1 ? res.data.data : this.data.couponList.concat(res.data.data);
      this.setData({
        couponList,
        totalPages: res.data.data.totalPages,
      })
      wx.hideLoading();
      if (type && type.pullDown) wx.stopPullDownRefresh();
    }).finally(() => {
      wx.hideLoading();
      this.setData({
        couponList: ''
      })
    })
  },
  /**
 * 页面相关事件处理函数--监听用户下拉动作
 */
  onPullDownRefresh: function () {
    this.setData({
      params: {
        pageNo: 1,
        pageSize: 10,
      },
    })
    this.getCouponList({
      pullDown: true
    });
  },

  /**
   * 页面上拉触底事件的处理函数
   */
  bindDownLoad: function () {
    if (this.data.params.pageNo < this.data.totalPages) {
      this.setData({
        params: {
          pageNo: this.data.params.pageNo + 1,
          pageSize: 10
        },
        loadDataDone: true
      })
      this.getCouponList()
    }
  },
})